#!/usr/bin/perl
use 5.020;
use warnings;
my %bits = (
    n => 11, e => 10, s => 9, w => 8,
    f =>  3, l =>  2, r => 1, b => 0,
);
my %directions = (
    n => 'north',
    e => 'east',
    s => 'south',
    w => 'west',
);
my %sides = (
    f => 'front',
    l => 'left',
    r => 'right',
    b => 'back',
);

print <<'EOT';
# Checks if we can go in a direction
# Params: $a0 - Direction to check
# Return: $v0 - true or false
# Note: This function is autogenerated.
_canGoDir:
    beq     $a0, EAST, cgd_east
    beq     $a0, SOUTH, cgd_south
    beq     $a0, WEST, cgd_west
EOT

while (my $line = <DATA>)
{
    chomp $line;
    my @cols = split /\s+/, $line;
    say '    cgd_', shift(@cols);
    for my $c (@cols)
    {
        my @bits = (0)x11;
        my ($d, $w) = split //, $c;
        printf <<'EOT', $bits{$d}, $directions{$d}, $bits{$w}, $sides{$w};
        srl     $t0, STATUS, %2d  # return false if
        andi    $t0, $t0, 1      #   facing %s &
        srl     $t1, STATUS, %2d  #   wall to the %s
        andi    $t1, $t1, 1
        and     $t0, $t0, $t1
        bne     $t0, $zero, cgd_returnFalse
EOT
    }
    say '    j   cgd_returnTrue';
}

print <<'EOT';
    cgd_returnFalse:
        or      $v0, $zero, $zero
jr  $ra
    cgd_returnTrue:
        li      $v0, 1
jr  $ra
# End of _canGoDir
EOT

#Bits are nesw[7..4]flrb
__DATA__
north: nf el sb wr
east:  nr ef sl wb
south: nb er sf wl
west:  nl eb sr wf
